VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCombination"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private c_FilePath As String     't@C̃pX
Private c_IniEdit As clsIniEdit  'Init@CNX
Private colCombination As Collection
Private lngCombinationCount As Long
Private p_FilePath As String
Private LayerNum As Long
Private dblScale As Double
Private dblMagnification As Double

Public blnAddLine As Boolean
Public blnOffsetLine1 As Boolean
Public blnOffsetLine2 As Boolean

Private Const LineStyle As Long = zwStyleSolid
Private Const LineWidth As Long = zwWidthThin



'NX
Private Sub Class_Initialize()
    Set c_IniEdit = New clsIniEdit
    blnAddLine = False
    blnOffsetLine1 = False
    blnOffsetLine2 = False
End Sub
'NXj
Private Sub Class_Terminate()
    Set colCombination = Nothing
    Set c_IniEdit = Nothing
End Sub

Public Property Let PatternFilePath(FilePath As String)
    p_FilePath = FilePath
End Property

Public Property Let LayerNumber(Num As Long)
    LayerNum = Num
End Property

'gݍ킹t@CpXvpeB
Public Property Let CombinationFilePath(FilePath As String)

    Set colCombination = Nothing
    Set colCombination = New Collection
    c_FilePath = FilePath
    With c_IniEdit
        .IniFilePath = c_FilePath
        lngCombinationCount = .GetSectionNames(colCombination)
    End With
    
End Property

Public Property Let dScale(s As Double)
    dblScale = s
End Property

Public Property Let dMag(m As Double)
    dblMagnification = m
End Property

'gݍ킹
Public Function Count() As Long
    Count = lngCombinationCount
End Function

Public Function Item(Num As Long) As String
    Item = colCombination.Item(Num)
End Function

Public Sub GetCombiLine(Name As String, PolyPoints As zwDrawCAD.DPoints, ByRef RapidGroup As zwDrawCAD.GroupData)




End Sub


Public Sub GetCombination(Name As String, ByRef colGroup As Collection, ByRef colWidth As Collection)

    Dim colKey As Collection
    Dim tmpPrim As Collection
    Dim tmpPattern As clsPattern
    Dim tmpGroup As zwDrawCAD.GroupData
    Dim lngKeyCount As Long
    Dim tmpWidth  As Double
    Dim strKeyName As String
    Dim i As Long

    Set colKey = New Collection
    Set tmpPattern = New clsPattern
    With tmpPattern
        .PatternFilePath = p_FilePath
        .dMag = dblMagnification
        .dScale = dblScale
    End With
    
    lngKeyCount = c_IniEdit.GetKeyNames(Name, colKey)
    
    For i = 1 To lngKeyCount
        strKeyName = colKey.Item(i)
        Select Case Left(strKeyName, 1)
            Case Is = "B"
                colGroup.Add tmpGroup
                colWidth.Add CDbl(c_IniEdit.GetInt(Name, strKeyName, 0)) * dblScale * dblMagnification / 100
            Case Is = "C"
                Set tmpPrim = New Collection
                tmpWidth = tmpPattern.GetPattern(c_IniEdit.GetString(Name, colKey.Item(i), ""), tmpPrim)
                Set tmpGroup = New zwDrawCAD.GroupData
                Call SetGroup(tmpGroup, tmpPrim)
                colGroup.Add tmpGroup
                colWidth.Add tmpWidth
                Set tmpGroup = Nothing
                Set tmpPrim = Nothing
            Case Is = "L"
                blnAddLine = True
            Case Is = "O"
                blnOffsetLine1 = True
            Case Is = "D"
                blnOffsetLine2 = True
            Case Else
        End Select
    Next i
    
    Set tmpGroup = Nothing
    Set tmpPrim = Nothing
    Set tmpPattern = Nothing
    Set colKey = Nothing

End Sub

Private Sub SetGroup(ByRef NewGroup As zwDrawCAD.GroupData, cPrim As Collection)

    Dim tempPrim As zwDrawCAD.Primitive
    
    For Each tempPrim In cPrim
        With tempPrim
            .LayerNo = LayerNum
            .PenStyle = LineStyle
            .PenWidth = LineWidth
        End With
        NewGroup.Add tempPrim
    Next
    
    Set tempPrim = Nothing
    
End Sub

'𕪊
Private Function SplitPoly(ByVal VPoints As zwDrawCAD.DPoints, ByVal SLength As Collection, _
                            ByRef SPoints As zwDrawCAD.DPoints, Splines As Collection) As Long

    Dim i As Long
    Dim c As Long
    Dim w As Long
    Dim dbltl As Double
    Dim dblx As Double
    Dim dbly As Double
    Dim dblsx As Double
    Dim dblsy As Double
    dblsx = VPoints.Item(0).x
    dblsy = VPoints.Item(0).y
    SPoints.Add dblsx, dblsy
    SplitPoly = 1
    c = VPoints.Count - 1
    w = 1
    
    Dim SplinePoints As zwDrawCAD.DPoints
    Set SplinePoints = New zwDrawCAD.DPoints
    SplinePoints.Add dblsx, dblsy
    
    For i = 1 To c
        F_Main.RapidTool.MessageBar = "WvZ...(" & Int((i / c) * 100) & "%)"
        dbltl = Length(dblsx, dblsy, VPoints.Item(i).x, VPoints.Item(i).y)
        Select Case dbltl
            Case Is < SLength.Item(w)
                SplinePoints.Add VPoints.Item(i).x, VPoints.Item(i).y
                
            Case Is = SLength.Item(w)
                SPoints.Add VPoints.Item(i).x, VPoints.Item(i).y
                SplitPoly = SplitPoly + 1
                dblsx = VPoints.Item(i).x
                dblsy = VPoints.Item(i).y
                
                SplinePoints.Add dblsx, dblsy
                Splines.Add SplinePoints
                Set SplinePoints = Nothing
                Set SplinePoints = New zwDrawCAD.DPoints
                SplinePoints.Add dblsx, dblsy
                
                w = w + 1
                If w > SLength.Count Then
                    w = 1
                End If
                
            Case Is > SLength.Item(w)
                Call Cross_CSL(dblsx, dblsy, SLength.Item(w), _
                               VPoints.Item(i - 1).x, VPoints.Item(i - 1).y, _
                               VPoints.Item(i).x, VPoints.Item(i).y, dblx, dbly)
                SPoints.Add dblx, dbly
                SplitPoly = SplitPoly + 1
                VPoints.Item(i - 1).x = dblx
                VPoints.Item(i - 1).y = dbly
                dblsx = dblx
                dblsy = dbly
                
                SplinePoints.Add dblsx, dblsy
                Splines.Add SplinePoints
                Set SplinePoints = Nothing
                Set SplinePoints = New zwDrawCAD.DPoints
                SplinePoints.Add dblsx, dblsy
                
                i = i - 1
                w = w + 1
                If w > SLength.Count Then
                    w = 1
                End If
                
            Case Else
        End Select
    Next
    
    If SLength.Item(w) / 3 < dbltl Then
        SPoints.Add VPoints.Item(i - 1).x, VPoints.Item(i - 1).y
        Splines.Add SplinePoints
        SplitPoly = SplitPoly + 1
    End If
    
    Set SplinePoints = Nothing

End Function

Private Sub AddParts(ByRef PGroup As zwDrawCAD.GroupData, PCol As Collection, PPoints As zwDrawCAD.DPoints)

    Dim tmpGroup As zwDrawCAD.GroupData
    
    Dim i As Long
    Dim p As Long
    Dim D As Double
    Dim c As zwDrawCAD.DPoint
    Set c = New zwDrawCAD.DPoint
    
    Dim g As zwDrawCAD.Global
    Set g = New zwDrawCAD.Global
    
    c.x = 0
    c.y = 0
    p = 1
    For i = 0 To PPoints.Count - 2
        If (PCol.Item(p) Is Nothing) = False Then
            Set tmpGroup = New zwDrawCAD.GroupData
            Set tmpGroup = PCol.Item(p).Copy
            D = Angle(PPoints.Item(i).x, PPoints.Item(i).y, PPoints.Item(i + 1).x, PPoints.Item(i + 1).y)
            D = g.RadianToDegree(D)
            tmpGroup.Rotate c, D
            tmpGroup.Move PPoints.Item(i).x, PPoints.Item(i).y
            PGroup.Add tmpGroup
            Set tmpGroup = Nothing
        End If
        p = p + 1
        If p > PCol.Count Then
            p = 1
        End If
    Next i
    Set c = Nothing
    Set g = Nothing
    
End Sub

